//+------------------------------------------------------------------+
//|                                     C12_UltimateRoundNumbers.mq4 |
//+------------------------------------------------------------------+
#property copyright   "https://www.forexfactory.com/c-12"
#property link        "https://www.forexfactory.com/c-12"
#property strict
#property indicator_chart_window
//---
input uint  GridStep=100;//Step, pips
extern string custom_grid=" type your custom grid pair separate by comma";
input string grid_1000_pairs="GOLD,XAUUSD,US30,US30.v,NAS100,FTSE100";
input string grid_10000_pairs="BTCUSD,XAUUSD.v";
input string grid_100000_pairs="USOIL,DE30.v";
input string grid_1000000_pairs="";
input color LineColor=clrDarkGray;//Color
input ENUM_LINE_STYLE LineStyle=STYLE_DOT;//Style
input string LineText="RoundNr";//Prefixzzzz
//---
string G1000[];
string G10000[];
string G100000[];
string G1000000[];


int OnInit()
{//Alert("indicator expired at 18 feb 2020");
 //if(TimeCurrent()>D'2020.02.18'){Alert("indi expired");ObjectsDeleteAll(); ExpertRemove();return(INIT_FAILED);}
 return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   
 //if(TimeCurrent()>D'2020.02.18'){Alert("indi expired");ObjectsDeleteAll(); ExpertRemove();return(INIT_FAILED);}

   if(prev_calculated==0)
     {
      double Highest=High[ArrayMaximum(High)];
      double Lowest=Low[ArrayMinimum(Low)];

      int coef_point=(_Digits==1 || _Digits==3 || _Digits==5)?10:1;
      
     uint GS=GridStep; 
    ushort u_sep=StringGetCharacter(",",0); 
    StringSplit(grid_1000_pairs,u_sep,G1000);
    int tot=ArraySize(G1000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000[x])>=0)GS=1000;
    
    }
    
    StringSplit(grid_10000_pairs,u_sep,G10000);
     tot=ArraySize(G10000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G10000[x])>=0)GS=10000;    
    }
    
    StringSplit(grid_100000_pairs,u_sep,G100000);
     tot=ArraySize(G100000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G100000[x])>=0)GS=100000;    
    }
    
    StringSplit(grid_1000000_pairs,u_sep,G1000000);
     tot=ArraySize(G1000000);
    for(int x=0;x<tot;x++)
    {if(StringFind(Symbol(),G1000000[x])>=0)GS=1000000;    
    }
    
    
      
      double Step=fmax(1,GS)*_Point*coef_point;

      double Max=round(1.1*Highest/Step)*Step;
      double Min=round(0.8*Lowest/Step)*Step;

      //Print(Max," ",Min," ",Step);

      for(double i=Min; i<=Max; i+=Step)
        {
         string obj_name=LineText+"_"+DoubleToString(i,_Digits);

         if(ObjectFind(0,obj_name)==0 || 
            ObjectCreate(0,obj_name,OBJ_HLINE,0,0,i))
           {
            ObjectSetInteger(0,obj_name,OBJPROP_STYLE,LineStyle);
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,LineColor);
            ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,False);
            ObjectSetDouble(0,obj_name,OBJPROP_PRICE,i);
           }
        }

      ChartRedraw();
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectsDeleteAll(0,LineText,0,-1);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
